package net.t2code.commandguiv2.Spigot.config.config;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.t2codelib.SPIGOT.api.items.T2CitemVersion;

import java.util.Arrays;
import java.util.Collections;

public enum Config {

    debug("Plugins.Debug", false),
    updateCheckOnJoin("Plugin.updateCheck.onJoin", true),
    updateCheckSeePreReleaseUpdates("Plugin.updateCheck.seePreReleaseUpdates", true),
    updateCheckTimeInterval("Plugin.updateCheck.timeInterval", 60),
    helpAlias("Plugin.HelpAlias", true),
    adminSubCommand("Plugin.AdminSubCommand", "admin"),
    language("Plugin.language", "english"),
    currency("Plugin.Currency", "$"),
    defaultGUI("Plugin.DefaultGUI", "default"),


    storage("Storage.Type", "YML"),
    mysqlIp("Storage.MySQL.IP", "localhost"),
    mysqlPort("Storage.MySQL.Port", 3306),
    mysqlDatabase("Storage.MySQL.Database", "database"),
    mysqlUser("Storage.MySQL.User", "root"),
    mysqlPassword("Storage.MySQL.Password", "password"),
    mysqlSSL("Storage.MySQL.SSL", false),


    useItem_Enable("UseItem.Enable", true),
    UseItem_AllowToggle("UseItem.AllowToggle", true),
    UseItem_AllowSetSlot("UseItem.AllowSetSlot", true),
    UseItem_BlockMoveAndDrop("UseItem.BlockMoveAndDrop", true),
    UseItem_OpenGUI("UseItem.OpenGUI", "default"),
    UseItem_Permission("UseItem.Permission.NeededToUse", true),
    UseItem_KeepAtCommandClear("UseItem.KeepAtCommandClear", true),
    UseItem_InventorySlot_FreeSlot("UseItem.InventorySlot.FreeSlot", 1),
    UseItem_InventorySlot("UseItem.InventorySlot.Slot", false),
    UseItem_InventorySlotEnforce("UseItem.InventorySlot.SlotEnforce", false),
    UseItem_Material("UseItem.Item.Material", "paper"),


    UseItem_PlayerHead_Enable("UseItem.Item.PlayerHead.Enable", false),
    UseItem_Base64_Enable("UseItem.Item.PlayerHead.Base64.Enable", false),
    UseItem_Base64value("UseItem.Item.PlayerHead.Base64.Base64Value", ""),
    UseItem_PlayerWhoHasOpenedTheGUI("UseItem.Item.PlayerHead.PlayerWhoHasOpenedTheGUI", false),
    UseItem_PlayerName("UseItem.Item.PlayerHead.PlayerName", ""),
    UseItem_Name("UseItem.Item.Name", "&bDefault &6GUI"),
    UseItem_Lore("UseItem.Item.Lore", Collections.singletonList("&eThis is an example GUI")),
    UseItem_GiveOnEveryJoin("UseItem.Join.GiveOnEveryJoin", true),
    UseItem_GiveOnlyOnFirstJoin("UseItem.Join.GiveOnlyOnFirstJoin", false),
    Cursor_ToGUIItem_OnLogin("UseItem.Join.Cursor.ToGUIItem.OnLogin.Enable", true),
    Cursor_ToGUIItem_OnlyOnFirstLogin("UseItem.Join.Cursor.ToGUIItem.Spigot.OnlyOnFirstLogin", true),
    UseItem_ServerChange("UseItem.Join.Cursor.ToGUIItem.Bungee.OnServerChange", false),


    toggleItemOnOrYesBase64("Toggle.Items.OnOrYes.Item.Base64.Enable", false),
    toggleItemOnOrYesBase64Value("Toggle.Items.OnOrYes.Item.Base64.Base64Value", ""),
    toggleItemOnOrYesMaterial("Toggle.Items.OnOrYes.Item.Material", Main.legacy ? "WOOL,5" : T2CitemVersion.getGreenWool().getType().toString()),
    toggleItemOffOrNoBase64("Toggle.Items.OffOrNo.Item.Base64.Enable", false),
    toggleItemOffOrNoBase64Value("Toggle.Items.OffOrNo.Item.Base64.Base64Value", T2CitemVersion.getGreenWool().getType().toString()),
    toggleItemOffOrNoMaterial("Toggle.Items.OffOrNo.Item.Material", Main.legacy ? "WOOL,14" : T2CitemVersion.getRedWool().getType().toString()),


    togglePermTrue("Toggle.Permission.Commands.True", "luckperms user [player] permission set [perm] true"),
    togglePermFalse("Toggle.Permission.Commands.False", "luckperms user [player] permission set [perm] false"),
    placeholderTrue("Placeholder.True", "&2true"),
    placeholderFalse("Placeholder.False", "&4false"),


    Sound_Enable("Sound.Enable", true),
    Sound_OpenInventory_Enable("Sound.OpenInventory.Sound", true),
    Sound_OpenInventory_input("Sound.OpenInventory.Sound", null), //todo sound create class
    Sound_Click_Enable("Sound.Click.Enable", null),
    Sound_Click_input("Sound.Click.Sound", null),
    Sound_NoMoney_Enable("Sound.NoMoney.Enable", null),
    Sound_NoMoney_input("Sound.NoMoney.Sound", null),


    Sound_NoInventorySpace_Enable("Sound.NoInventorySpace.Enable", null),
    Sound_NoInventorySpace_input("Sound.NoInventorySpace.Sound", null),
    Sound_Give_Enable("Sound.Give.Enable", null),
    Sound_Give_input("Sound.Give.Sound", null),
    Sound_PlayerNotFound_Enable("Sound.PlayerNotFound.Enable", null),
    Sound_PlayerNotFound_input("Sound.PlayerNotFound.Sound", null),


    UseItemGameModeChangeEnable("Advanced.UseItem.GameMode.Change.Enable", null),
    UseItemGameModeChangeDelayInTicks("Advanced.UseItem.GameMode.Change.DelayInTicks", null),
    UseItemGameModeProtection("Advanced.UseItem.GameMode.Protection.Enable", null),
    UseItemGameModeRemoveItemWhenItIsDisabled("Advanced.UseItem.GameMode.Protection.RemoveItemWhenItIsDisabled", null),
    UseItemGameModeMode("Advanced.UseItem.GameMode.Protection.Mode", null),
    UseItemGameModeList("Advanced.UseItem.GameMode.Protection.List", null),

    UseItemWorldChangeEnable("Advanced.UseItem.World.Change.Enable", null),
    UseItemWorldChangeDelayInTicks("Advanced.UseItem.World.Change.DelayInTicks", null),
    UseItemWorldProtection("Advanced.UseItem.World.Protection.Enable", null),
    UseItemWorldRemoveItemWhenItIsDisabled("Advanced.UseItem.World.Protection.RemoveItemWhenItIsDisabled", null),
    UseItemWorldMode("Advanced.UseItem.World.Protection.Mode", null),
    UseItemWorldList("Advanced.UseItem.World.Protection.List", null),


    disableInfoBySneak("Advanced.UseItem.DisableInfoBySneak", null),
    UseItemItemBlockBlacklist("Advanced.UseItem.ItemBlockBlacklist", null);


    public final String path;
    public Object value;

    Config(String path, Object defaultValue) {
        this.path = path;
        this.value = defaultValue;
    }
}
